program APIHOOK;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  Windows,
  ProcMan in '..\..\prj\SysSafe\procman.pas';

type
  THList = array[0..255] of record Id, Handle: DWORD; end;

  TImportCode = packed record
    JumpInstruction: Word; //  JMP.   $25FF
    AddressOfPointerToFunction: PPointer;
  end;
  PImportCode = ^TImportCode;

var
  Event: TDebugEvent;
  dwContinueStatus: DWORD;
  CurThread: DWORD;
  HProc, BaseProc: DWORD;
  Context: TContext;
  ThreadList: THList;
  RetAddr: DWORD;
  BPAddr: DWORD;
  OrigByte: Byte;
  RestoreBreak: Boolean;
  ProcessFinished: Boolean;
  by, wh: pchar;

procedure WriteProcessByte(Base, Offset: DWORD; what: pointer);
var
  q: DWORD;
begin
  WriteProcessMemory(Base, Pointer(Offset), what, 1, q);
end;

function WriteInt3(Base, Offset: DWORD):byte;
var
  instr: byte;
  q, pto: DWORD;
begin
  ReadProcessMemory(Base, Pointer(Offset), @instr, 1, q);
  result:=instr;
  instr:=$CC;
  WriteProcessByte(Base, Offset, @instr);
end;

function FinalFunctionAddress(Code: Pointer): Pointer; //   -,   
var func: PImportCode;
begin
  Result:=Code;
  if Code=nil then exit;
  try
    func:=code;
    if (func.JumpInstruction=$25FF) then begin
      Result:=func.AddressOfPointerToFunction^;
    end;
  except
    Result:=nil;
  end;
end;

procedure ProcessDLLExport(PrcH: DWORD);
var
DLLName: string;
N: Pointer;
begin
if (BPAddr <> 0) then exit;
N := FinalFunctionAddress(@CreateProcessW);
BPAddr := DWORD(N);
OrigByte := WriteInt3(PrcH, BPAddr);
end;

function  GetThreadHandleFromList(List: THlist; TID: DWORD): DWORD;
var
  x: integer;
begin
result:=0;
  for x:=0 to 255 do
    if List[x].Id=tid then
      begin
        result:=List[x].Handle;
        break;
      end;
end;

function  AddThreadToList(var List: THlist; TID, TH: DWORD): DWORD;
var
  x,y: integer;
begin
y:=0;
 for x:=0 to 255 do
    if List[x].Id=tid then
      begin
        y:=x;
        break;
      end;
if y=0 then
 for x:=0 to 255 do
    if List[x].Id=0 then
      begin
        y:=x;
        break;
      end;
List[y].Id:=TID;
List[y].Handle:=TH;
result:=y;
end;

procedure DeleteThreadFromList(var List: THlist; TID: DWORD);
var
  x,y: integer;
begin
y:=0;
 for x:=0 to 255 do
    if List[x].Id=tid then
      begin
        y:=x;
        break;
      end;
if y=0 then exit;
List[y].Id:=0;
List[y].Handle:=0;
end;

begin

  EnablePrivilege('SeDebugPrivilege'); //  NT        ( .. SYSTEM)
  write('PID: ');
  readln(HProc);
  BaseProc:=OpenProcess(PROCESS_ALL_ACCESS, false, HProc);
  BPAddr:=0;
  ProcessDLLExport(BaseProc);
  DebugActiveProcess(Hproc);
  FillChar(ThreadList, SizeOf(ThreadList), 0);
  HProc := 0;
  ProcessFinished := True;
  RestoreBreak := False;
  repeat
    if not WaitForDebugEvent(Event, INFINITE) then break;
    dwContinueStatus := DBG_EXCEPTION_NOT_HANDLED;
    CurThread := GetThreadHandleFromList(ThreadList, Event.dwThreadId);
    case Event.dwDebugEventCode of
      CREATE_PROCESS_DEBUG_EVENT:
        begin
          HProc := Event.CreateProcessInfo.hFile;
          GetMem(by, 1024);
          GetModuleFileName(DWORD(Event.CreateProcessInfo.lpBaseOfImage), by, 1024);
//          by:=pchar(Event.CreateProcessInfo.lpImageName);
          Writeln('Creating: ', by);
          Freemem(by);
          ProcessFinished := False;
          AddThreadToList(ThreadList, Event.dwThreadId, Event.CreateProcessInfo.hThread);
        end;
      EXIT_PROCESS_DEBUG_EVENT:
        begin
          ProcessFinished := True;
          ContinueDebugEvent(Event.dwProcessId, Event.dwThreadId, DBG_CONTINUE);
          break;
        end;
      CREATE_THREAD_DEBUG_EVENT:
        AddThreadToList(ThreadList, Event.dwThreadId, Event.CreateThread.hThread);
      EXIT_THREAD_DEBUG_EVENT:
        DeleteThreadFromList(ThreadList, Event.dwThreadId);
      LOAD_DLL_DEBUG_EVENT:
        begin
          GetMem(by, 1024);
          GetModuleFileName(DWORD(Event.LoadDll.lpBaseOfDll), by, 1024);
          Writeln('Loading DLL: ', by);
          Freemem(by);
        end;
      UNLOAD_DLL_DEBUG_EVENT:
        WriteLn('Unloading DLL: ', IntToHex(DWORD(Event.UnloadDll.lpBaseOfDll), 8));
      EXCEPTION_DEBUG_EVENT:
        case Event.Exception.ExceptionRecord.ExceptionCode of
          EXCEPTION_BREAKPOINT:
            begin
              dwContinueStatus := DBG_CONTINUE;
              Context.ContextFlags := CONTEXT_CONTROL or CONTEXT_INTEGER or CONTEXT_SEGMENTS;
              GetThreadContext(CurThread, Context);
              if (BPAddr <> 0) and (Context.EIP = BPAddr + 1) then
                begin
//                  RetAddr := ReadProcessLong(HProc, Context.ESP);
//                  WriteLn('Return address: 0x', IntToHex(RetAddr, 8));
                  WriteLn('Debugger breakpoint');
                  Context.EIP := BPAddr;
                  WriteProcessByte(BaseProc, BPAddr, @OrigByte);
                  RestoreBreak := True;
                  Context.EFlags := Context.EFlags or EFLAGS_TRACE;
                  Context.ContextFlags := CONTEXT_CONTROL;
                  SetThreadContext(CurThread, Context);
                end;
            end;
          EXCEPTION_SINGLE_STEP:
            begin
              dwContinueStatus := DBG_CONTINUE;
              Context.ContextFlags := CONTEXT_CONTROL;
              GetThreadContext(CurThread, Context);
              if RestoreBreak and (Context.EIP >= BPAddr) and (Context.EIP <= BPAddr + 32) then
                begin
                  OrigByte := WriteInt3(BaseProc, BPAddr);
                  RestoreBreak := False;

                    Context.EFlags := Context.EFlags and not EFLAGS_TRACE;
                end else
                if RestoreBreak then Context.EFlags := Context.EFlags or EFLAGS_TRACE;

              Context.ContextFlags := CONTEXT_CONTROL;
              SetThreadContext(CurThread, Context);
          end;
      end;
  end;

  if not ContinueDebugEvent(Event.dwProcessId, Event.dwThreadId, dwContinueStatus) then break;
until 1=2;

Writeln('Debugger finished it''s job.');
readln;
end.
